(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports);
    global.unknown = mod.exports;
  }
})(this, function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;
  !function (global) {
    "use strict";

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined;
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
    var inModule = typeof module === "object";
    var runtime = global.regeneratorRuntime;

    if (runtime) {
      if (inModule) {
        module.exports = runtime;
      }

      return;
    }

    runtime = global.regeneratorRuntime = inModule ? module.exports || {} : {};

    function wrap(innerFn, outerFn, self, tryLocsList) {
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);
      generator._invoke = makeInvokeMethod(innerFn, self, context);
      return generator;
    }

    runtime.wrap = wrap;

    function tryCatch(fn, obj, arg) {
      try {
        return {
          type: "normal",
          arg: fn.call(obj, arg)
        };
      } catch (err) {
        return {
          type: "throw",
          arg: err
        };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";
    var ContinueSentinel = {};

    function Generator() {}

    function GeneratorFunction() {}

    function GeneratorFunctionPrototype() {}

    var IteratorPrototype = {};

    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

    if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunctionPrototype[toStringTagSymbol] = GeneratorFunction.displayName = "GeneratorFunction";

    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function (method) {
        prototype[method] = function (arg) {
          return this._invoke(method, arg);
        };
      });
    }

    runtime.isGeneratorFunction = function (genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor ? ctor === GeneratorFunction || (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
    };

    runtime.mark = function (genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;

        if (!(toStringTagSymbol in genFun)) {
          genFun[toStringTagSymbol] = "GeneratorFunction";
        }
      }

      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    runtime.awrap = function (arg) {
      return {
        __await: arg
      };
    };

    function AsyncIterator(generator) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);

        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;

          if (value && typeof value === "object" && hasOwn.call(value, "__await")) {
            return Promise.resolve(value.__await).then(function (value) {
              invoke("next", value, resolve, reject);
            }, function (err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return Promise.resolve(value).then(function (unwrapped) {
            result.value = unwrapped;
            resolve(result);
          }, function (error) {
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new Promise(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }

      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);

    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };

    runtime.AsyncIterator = AsyncIterator;

    runtime.async = function (innerFn, outerFn, self, tryLocsList) {
      var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList));
      return runtime.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
        return result.done ? result.value : iter.next();
      });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;
      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            context.sent = context._sent = context.arg;
          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);
          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;
          var record = tryCatch(innerFn, self, context);

          if (record.type === "normal") {
            state = context.done ? GenStateCompleted : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };
          } else if (record.type === "throw") {
            state = GenStateCompleted;
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];

      if (method === undefined) {
        context.delegate = null;

        if (context.method === "throw") {
          if (delegate.iterator.return) {
            context.method = "return";
            context.arg = undefined;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError("The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (!info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        context[delegate.resultName] = info.value;
        context.next = delegate.nextLoc;

        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined;
        }
      } else {
        return info;
      }

      context.delegate = null;
      return ContinueSentinel;
    }

    defineIteratorMethods(Gp);
    Gp[toStringTagSymbol] = "Generator";

    Gp[iteratorSymbol] = function () {
      return this;
    };

    Gp.toString = function () {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = {
        tryLoc: locs[0]
      };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      this.tryEntries = [{
        tryLoc: "root"
      }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    runtime.keys = function (object) {
      var keys = [];

      for (var key in object) {
        keys.push(key);
      }

      keys.reverse();
      return function next() {
        while (keys.length) {
          var key = keys.pop();

          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];

        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1,
              next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined;
            next.done = true;
            return next;
          };

          return next.next = next;
        }
      }

      return {
        next: doneResult
      };
    }

    runtime.values = values;

    function doneResult() {
      return {
        value: undefined,
        done: true
      };
    }

    Context.prototype = {
      constructor: Context,
      reset: function (skipTempReset) {
        this.prev = 0;
        this.next = 0;
        this.sent = this._sent = undefined;
        this.done = false;
        this.delegate = null;
        this.method = "next";
        this.arg = undefined;
        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
              this[name] = undefined;
            }
          }
        }
      },
      stop: function () {
        this.done = true;
        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;

        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },
      dispatchException: function (exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;

        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            context.method = "next";
            context.arg = undefined;
          }

          return !!caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }
            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }
            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },
      abrupt: function (type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },
      complete: function (record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" || record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },
      finish: function (finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },
      "catch": function (tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];

          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;

            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }

            return thrown;
          }
        }

        throw new Error("illegal catch attempt");
      },
      delegateYield: function (iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          this.arg = undefined;
        }

        return ContinueSentinel;
      }
    };
  }(function () {
    return this || typeof self === "object" && self;
  }() || Function("return this")());
  undefined;
  const disableBlocks = {
    debug: ["infared_ir_best_codes_arduino_remote.BLOCK_1653576003808", "infared_ir_best_codes_arduino_remote.BLOCK_1653588721838"],
    upload: []
  };
  const mustLoginBlocks = [];

  const triggerBlocksStatus = async (mode, app) => {};

  class ExtImpl {}

  const extTranslationMap = {
    "zh": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "de": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "es": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "fr": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "id": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "ja": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "ja-jph": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "ko": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "pl": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "uk": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "zh-hant": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "nl": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "it": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "hr": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "ru": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "pt": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "fi": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "tr": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "tk": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    },
    "en": {
      "infared_ir_best_codes_arduino_remote": "Arduino IR Remote",
      "extensionName": "Arduino IR Remote",
      "extensionDescription": "A simple, easy to use IR remote extension for Arduinos (particularly Unos) that works. Made by Best_codes.",
      "BLOCK_1653576003808": "[ICON]IR sensor on digital pin [PORT] code received ",
      "BLOCK_1653588721838_REMTYPE_0": "UNKNOWN",
      "BLOCK_1653588721838_REMTYPE_1": "NECS",
      "BLOCK_1653588721838_REMTYPE_2": "SONY",
      "BLOCK_1653588721838_REMTYPE_3": "RC5 (common)",
      "BLOCK_1653588721838_REMTYPE_4": "RC6",
      "BLOCK_1653588721838_REMTYPE_5": "DISH",
      "BLOCK_1653588721838_REMTYPE_6": "SHARP",
      "BLOCK_1653588721838_REMTYPE_7": "PANASONIC",
      "BLOCK_1653588721838_REMTYPE_8": "JVC",
      "BLOCK_1653588721838_REMTYPE_9": "SANYO",
      "BLOCK_1653588721838_REMTYPE_10": "MITSUBISHI",
      "BLOCK_1653588721838_REMTYPE_11": "SAMSUNG",
      "BLOCK_1653588721838_REMTYPE_12": "LG",
      "BLOCK_1653588721838_REMTYPE_13": "WHYNTER",
      "BLOCK_1653588721838": "[IMAGE] IR remote digital pin [pin] signal received type is [remtype] ",
      "cate_0db9b236": "IR remote"
    }
  };
  const codeSnippets = {
    arduinoc: {}
  };
  const extGenerators = [{
    lang: 'arduinoc',
    template: `// generated by mBlock5 and Best_codes for <your product>
// codes make you happy

//( include //)
#include <Arduino.h>
//( lib //)

//({
    this.$ALL_VARIABLES.length==0?'':this.$ALL_VARIABLES.map(v=>"float "+v+" = 0;").join('\\n')
}//)

//( declare //)


void _delay(float seconds) {
  long endTime = millis() + seconds * 1000;
  while(millis() < endTime) _loop();
}

//(
void setup() {
  //( setup //)
  //( code //)
}
//)

void _loop() {
  //( _loop //)
}

void loop() {
  _loop();
}`,
    splitor: {
      frame: {
        left: "//(",
        right: "//)"
      },
      expression: {
        left: "/*{",
        right: "}*/"
      }
    },
    reducers: [{
      name: 'include',
      reduce: codes => {
        let codes1 = [];

        for (let code of codes) {
          let codeStr = '';

          if (typeof code === 'string') {
            codeStr = code;
          } else if (typeof code === 'function') {
            codeStr = code();
          }

          if (codes1.indexOf(codeStr) === -1) {
            codes1.push(codeStr);
          }
        }

        if (codes1.length === 0) {
          return undefined;
        }

        return codes1.map(code => {
          return '#include ' + code;
        }).join('\n') + '\n';
      }
    }]
  }];
  const extSources = {
    arduino: [{
      filename: "src/IRremoteExt.cpp",
      code: "#include \"IRremote_ard.h\"\n#include \"IRremoteExt.h\"\n#include <Arduino.h>\n\nIRrecv* __irrecv; // an instance of the IR receiver object\ndecode_results __results; // container for received IR codes\n\n__ir_handler_type \t__ir_handler[2][21];\nunsigned long\t\t__ir_handler_code[21];\nint   \t\t\t\t__ir_handler_count=0;\nint\t\t\t\t\t__last_code_H=-1;\nunsigned long\t\t__last_code=REPEAT;\nunsigned long\t\t__last_Rel_code=REPEAT;\nunsigned long\t\t__prev_millis=0;\n\nvoid beginIRremote(int pin){\n\t__irrecv = new IRrecv(pin);\n\t__irrecv->enableIRIn(); // Start the receiver\n}\n\nvoid addPressHandlerIRremote(unsigned long code, __ir_handler_type func){\n\t\t\n\tfor(int i=0;i<__ir_handler_count;i++)\n\t\tif(__ir_handler_code[i] == code){\n\t\t\t__ir_handler[0][i] = func;\n\t\t\treturn;\n\t\t}\n\t\n\tif(__ir_handler_count >= 21)\n\t\treturn;\n\t\n\t__ir_handler_code[__ir_handler_count] = code;\n\t__ir_handler[0][__ir_handler_count] = func;\n\t__ir_handler[1][__ir_handler_count++] = NULL;\n}\n\nvoid addReleaseHandlerIRremote(unsigned long code, __ir_handler_type func){\n\t\t\n\tfor(int i=0;i<__ir_handler_count;i++)\n\t\tif(__ir_handler_code[i] == code){\n\t\t\t__ir_handler[1][i] = func;\n\t\t\treturn;\n\t\t}\n\t\n\tif(__ir_handler_count >= 21)\n\t\treturn;\n\t\n\t__ir_handler_code[__ir_handler_count] = code;\n\t__ir_handler[1][__ir_handler_count] = func;\n\t__ir_handler[0][__ir_handler_count++] = NULL;\n}\n\nvoid handleIRremote(){\n\t\n\tif (__irrecv->decode(&__results)) {\n\t\t__prev_millis =  millis();\n\t\tif(\t__results.value == REPEAT || \n\t\t\t__last_code != REPEAT){ // this code can't handle pressing of two buttons before releasing the first one\n\t\t\t__irrecv->resume(); // Receive the next value\n\t\t\treturn;\n\t\t}\n\t\t\n\t\t__last_code = __results.value;\n\t\t\n\t\tfor(int i=0;i<__ir_handler_count;i++)\n\t\t\tif(__results.value == __ir_handler_code[i]){\n\t\t\t\tif(__ir_handler[0][i]) __ir_handler[0][i](__results.value);\n\t\t\t\t__last_code_H = i;\n\t\t\t\tbreak;\n\t\t\t}\n\t\t\n\t\t__irrecv->resume(); // Receive the next value\n\t\treturn;\n\t}\n\t\n\tunsigned long cur_millis = millis();\n\tif(__last_code != REPEAT && (cur_millis - __prev_millis) > 200){\n\t\t\n\t\tif(__last_code_H != -1 && __ir_handler[1][__last_code_H]){\n\t\t\t__ir_handler[1][__last_code_H](__last_code);\n\t\t\t__last_code_H = -1;\n\t\t}\n\t\t__last_Rel_code = __last_code;\n\t\t__last_code = REPEAT;\n\t}\n}\n\nunsigned long getPressedIRremote(){\n\treturn __last_code;\n}\n\nbool isReleasedIRremote(unsigned long code){\n\tif(code == __last_Rel_code){\n\t\t__last_Rel_code = REPEAT;\n\t\treturn true;\n\t}\n\t\n\treturn false;\n}"
    }, {
      filename: "src/IRremoteExt.h",
      code: "#ifndef IRREMOTEEXT_H\n#define IRREMOTEEXT_H\n\ntypedef void (*__ir_handler_type)(unsigned long);\n\nextern void beginIRremote(int pin);\n\nextern void addPressHandlerIRremote(unsigned long code, __ir_handler_type func);\nextern void addReleaseHandlerIRremote(unsigned long code, __ir_handler_type func);\n\nextern void handleIRremote();\nextern unsigned long getPressedIRremote();\nextern bool isReleasedIRremote(unsigned long code);\n\n\n#define IR_CODE_PWR\t\t0xFFA25D\n#define IR_CODE_MODE\t0xFF629D\n#define IR_CODE_MUTE\t0xFFE21D\n#define IR_CODE_PLAY\t0xFF22DD\n#define IR_CODE_FWD\t\t0xFF02FD\n#define IR_CODE_BKD\t\t0xFFC23D\n#define IR_CODE_EQ\t\t0xFFE01F\n#define IR_CODE_MINUS\t0xFFA857\n#define IR_CODE_PLUS\t0xFF906F\n#define IR_CODE_0\t\t0xFF6897\n#define IR_CODE_CROSS\t0xFF9867\n#define IR_CODE_SD\t\t0xFFB04F\n#define IR_CODE_1\t\t0xFF30CF\n#define IR_CODE_2\t\t0xFF18E7\n#define IR_CODE_3\t\t0xFF7A85\n#define IR_CODE_4\t\t0xFF10EF\n#define IR_CODE_5\t\t0xFF38C7\n#define IR_CODE_6\t\t0xFF5AA5\n#define IR_CODE_7\t\t0xFF42BD\n#define IR_CODE_8\t\t0xFF4AB5\n#define IR_CODE_9\t\t0xFF52AD\n\n#endif"
    }, {
      filename: "src/IRremoteInt_ard.h",
      code: "/*\n * IRremote\n * Version 0.1 July, 2009\n * Copyright 2009 Ken Shirriff\n * For details, see http://arcfn.com/2009/08/multi-protocol-infrared-remote-library.html\n *\n * Modified by Paul Stoffregen <paul@pjrc.com> to support other boards and timers\n *\n * Interrupt code based on NECIRrcv by Joe Knapp\n * http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1210243556\n * Also influenced by http://zovirl.com/2008/11/12/building-a-universal-remote-with-an-arduino/\n *\n * JVC and Panasonic protocol added by Kristian Lauszus (Thanks to zenwheel and other people at the original blog post)\n */\n\n#ifndef IRremoteint_h\n#define IRremoteint_h\n\n#if defined(ARDUINO) && ARDUINO >= 100\n#include <Arduino.h>\n#else\n#include <WProgram.h>\n#endif\n\n// define which timer to use\n//\n// Uncomment the timer you wish to use on your board.  If you\n// are using another library which uses timer2, you have options\n// to switch IRremote to use a different timer.\n\n// Arduino Mega\n#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n  //#define IR_USE_TIMER1   // tx = pin 11\n  #define IR_USE_TIMER2     // tx = pin 9\n  //#define IR_USE_TIMER3   // tx = pin 5\n  //#define IR_USE_TIMER4   // tx = pin 6\n  //#define IR_USE_TIMER5   // tx = pin 46\n\n// Teensy 1.0\n#elif defined(__AVR_AT90USB162__)\n  #define IR_USE_TIMER1     // tx = pin 17\n\n// Teensy 2.0\n#elif defined(__AVR_ATmega32U4__)\n  //#define IR_USE_TIMER1   // tx = pin 14\n  //#define IR_USE_TIMER3   // tx = pin 9\n  #define IR_USE_TIMER4_HS  // tx = pin 10\n\n// Teensy++ 1.0 & 2.0\n#elif defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB1286__)\n  //#define IR_USE_TIMER1   // tx = pin 25\n  #define IR_USE_TIMER2     // tx = pin 1\n  //#define IR_USE_TIMER3   // tx = pin 16\n\n// Sanguino\n#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644__)\n  //#define IR_USE_TIMER1   // tx = pin 13\n  #define IR_USE_TIMER2     // tx = pin 14\n\n// Atmega8\n#elif defined(__AVR_ATmega8P__) || defined(__AVR_ATmega8__)\n  #define IR_USE_TIMER1   // tx = pin 9\n\n// Arduino Duemilanove, Diecimila, LilyPad, Mini, Fio, etc\n#else\n  //#define IR_USE_TIMER1   // tx = pin 9\n  #define IR_USE_TIMER2     // tx = pin 3\n#endif\n\n\n\n#ifdef F_CPU\n#define SYSCLOCK F_CPU     // main Arduino clock\n#else\n#define SYSCLOCK 16000000  // main Arduino clock\n#endif\n\n#define ERR 0\n#define DECODED 1\n\n\n// defines for setting and clearing register bits\n#ifndef cbi\n#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))\n#endif\n#ifndef sbi\n#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))\n#endif\n\n// Pulse parms are *50-100 for the Mark and *50+100 for the space\n// First MARK is the one after the long gap\n// pulse parameters in usec\n#define NEC_HDR_MARK\t9000\n#define NEC_HDR_SPACE\t4500\n#define NEC_BIT_MARK\t560\n#define NEC_ONE_SPACE\t1600\n#define NEC_ZERO_SPACE\t560\n#define NEC_RPT_SPACE\t2250\n\n#define SONY_HDR_MARK\t2400\n#define SONY_HDR_SPACE\t600\n#define SONY_ONE_MARK\t1200\n#define SONY_ZERO_MARK\t600\n#define SONY_RPT_LENGTH 45000\n#define SONY_DOUBLE_SPACE_USECS  500  // usually ssee 713 - not using ticks as get number wrapround\n\n// SA 8650B\n#define SANYO_HDR_MARK\t3500  // seen range 3500\n#define SANYO_HDR_SPACE\t950 //  seen 950\n#define SANYO_ONE_MARK\t2400 // seen 2400  \n#define SANYO_ZERO_MARK 700 //  seen 700\n#define SANYO_DOUBLE_SPACE_USECS  800  // usually ssee 713 - not using ticks as get number wrapround\n#define SANYO_RPT_LENGTH 45000\n\n// Mitsubishi RM 75501\n// 14200 7 41 7 42 7 42 7 17 7 17 7 18 7 41 7 18 7 17 7 17 7 18 7 41 8 17 7 17 7 18 7 17 7 \n\n// #define MITSUBISHI_HDR_MARK\t250  // seen range 3500\n#define MITSUBISHI_HDR_SPACE\t350 //  7*50+100\n#define MITSUBISHI_ONE_MARK\t1950 // 41*50-100\n#define MITSUBISHI_ZERO_MARK  750 // 17*50-100\n// #define MITSUBISHI_DOUBLE_SPACE_USECS  800  // usually ssee 713 - not using ticks as get number wrapround\n// #define MITSUBISHI_RPT_LENGTH 45000\n\n\n#define RC5_T1\t\t889\n#define RC5_RPT_LENGTH\t46000\n\n#define RC6_HDR_MARK\t2666\n#define RC6_HDR_SPACE\t889\n#define RC6_T1\t\t444\n#define RC6_RPT_LENGTH\t46000\n\n#define SHARP_BIT_MARK 245\n#define SHARP_ONE_SPACE 1805\n#define SHARP_ZERO_SPACE 795\n#define SHARP_GAP 600000\n#define SHARP_TOGGLE_MASK 0x3FF\n#define SHARP_RPT_SPACE 3000\n\n#define DISH_HDR_MARK 400\n#define DISH_HDR_SPACE 6100\n#define DISH_BIT_MARK 400\n#define DISH_ONE_SPACE 1700\n#define DISH_ZERO_SPACE 2800\n#define DISH_RPT_SPACE 6200\n#define DISH_TOP_BIT 0x8000\n\n#define PANASONIC_HDR_MARK 3502\n#define PANASONIC_HDR_SPACE 1750\n#define PANASONIC_BIT_MARK 502\n#define PANASONIC_ONE_SPACE 1244\n#define PANASONIC_ZERO_SPACE 400\n\n#define JVC_HDR_MARK 8000\n#define JVC_HDR_SPACE 4000\n#define JVC_BIT_MARK 600\n#define JVC_ONE_SPACE 1600\n#define JVC_ZERO_SPACE 550\n#define JVC_RPT_LENGTH 60000\n\n#define SHARP_BITS 15\n#define DISH_BITS 16\n\n#define TOLERANCE 25  // percent tolerance in measurements\n#define LTOL (1.0 - TOLERANCE/100.) \n#define UTOL (1.0 + TOLERANCE/100.) \n\n#define _GAP 5000 // Minimum map between transmissions\n#define GAP_TICKS (_GAP/USECPERTICK)\n\n#define TICKS_LOW(us) (int) (((us)*LTOL/USECPERTICK))\n#define TICKS_HIGH(us) (int) (((us)*UTOL/USECPERTICK + 1))\n\n// receiver states\n#define STATE_IDLE     2\n#define STATE_MARK     3\n#define STATE_SPACE    4\n#define STATE_STOP     5\n\n// information for the interrupt handler\ntypedef struct {\n  uint8_t recvpin;           // pin for IR data from detector\n  uint8_t rcvstate;          // state machine\n  uint8_t blinkflag;         // TRUE to enable blinking of pin 13 on IR processing\n  unsigned int timer;     // state timer, counts 50uS ticks.\n  unsigned int rawbuf[RAWBUF]; // raw data\n  uint8_t rawlen;         // counter of entries in rawbuf\n} \nirparams_t;\n\n// Defined in IRremote.cpp\nextern volatile irparams_t irparams;\n\n// IR detector output is active low\n#define MARK  0\n#define SPACE 1\n\n#define TOPBIT 0x80000000\n\n#define NEC_BITS 32\n#define SONY_BITS 12\n#define SANYO_BITS 12\n#define MITSUBISHI_BITS 16\n#define MIN_RC5_SAMPLES 11\n#define MIN_RC6_SAMPLES 1\n#define PANASONIC_BITS 48\n#define JVC_BITS 16\n\n\n\n\n// defines for timer2 (8 bits)\n#if defined(IR_USE_TIMER2)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR2A |= _BV(COM2B1))\n#define TIMER_DISABLE_PWM    (TCCR2A &= ~(_BV(COM2B1)))\n#define TIMER_ENABLE_INTR    (TIMSK2 = _BV(OCIE2A))\n#define TIMER_DISABLE_INTR   (TIMSK2 = 0)\n#define TIMER_INTR_NAME      TIMER2_COMPA_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint8_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR2A = _BV(WGM20); \\\n  TCCR2B = _BV(WGM22) | _BV(CS20); \\\n  OCR2A = pwmval; \\\n  OCR2B = pwmval / 3; \\\n})\n#define TIMER_COUNT_TOP      (SYSCLOCK * USECPERTICK / 1000000)\n#if (TIMER_COUNT_TOP < 256)\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR2A = _BV(WGM21); \\\n  TCCR2B = _BV(CS20); \\\n  OCR2A = TIMER_COUNT_TOP; \\\n  TCNT2 = 0; \\\n})\n#else\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR2A = _BV(WGM21); \\\n  TCCR2B = _BV(CS21); \\\n  OCR2A = TIMER_COUNT_TOP / 8; \\\n  TCNT2 = 0; \\\n})\n#endif\n#if defined(CORE_OC2B_PIN)\n#define TIMER_PWM_PIN        CORE_OC2B_PIN  /* Teensy */\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define TIMER_PWM_PIN        9  /* Arduino Mega */\n#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644__)\n#define TIMER_PWM_PIN        14 /* Sanguino */\n#else\n#define TIMER_PWM_PIN        3  /* Arduino Duemilanove, Diecimila, LilyPad, etc */\n#endif\n\n\n// defines for timer1 (16 bits)\n#elif defined(IR_USE_TIMER1)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR1A |= _BV(COM1A1))\n#define TIMER_DISABLE_PWM    (TCCR1A &= ~(_BV(COM1A1)))\n#if defined(__AVR_ATmega8P__) || defined(__AVR_ATmega8__)\n  #define TIMER_ENABLE_INTR    (TIMSK = _BV(OCIE1A))\n  #define TIMER_DISABLE_INTR   (TIMSK = 0)\n#else\n  #define TIMER_ENABLE_INTR    (TIMSK1 = _BV(OCIE1A))\n  #define TIMER_DISABLE_INTR   (TIMSK1 = 0)\n#endif\n#define TIMER_INTR_NAME      TIMER1_COMPA_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint16_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR1A = _BV(WGM11); \\\n  TCCR1B = _BV(WGM13) | _BV(CS10); \\\n  ICR1 = pwmval; \\\n  OCR1A = pwmval / 3; \\\n})\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR1A = 0; \\\n  TCCR1B = _BV(WGM12) | _BV(CS10); \\\n  OCR1A = SYSCLOCK * USECPERTICK / 1000000; \\\n  TCNT1 = 0; \\\n})\n#if defined(CORE_OC1A_PIN)\n#define TIMER_PWM_PIN        CORE_OC1A_PIN  /* Teensy */\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define TIMER_PWM_PIN        11  /* Arduino Mega */\n#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644__)\n#define TIMER_PWM_PIN        13 /* Sanguino */\n#else\n#define TIMER_PWM_PIN        9  /* Arduino Duemilanove, Diecimila, LilyPad, etc */\n#endif\n\n\n// defines for timer3 (16 bits)\n#elif defined(IR_USE_TIMER3)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR3A |= _BV(COM3A1))\n#define TIMER_DISABLE_PWM    (TCCR3A &= ~(_BV(COM3A1)))\n#define TIMER_ENABLE_INTR    (TIMSK3 = _BV(OCIE3A))\n#define TIMER_DISABLE_INTR   (TIMSK3 = 0)\n#define TIMER_INTR_NAME      TIMER3_COMPA_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint16_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR3A = _BV(WGM31); \\\n  TCCR3B = _BV(WGM33) | _BV(CS30); \\\n  ICR3 = pwmval; \\\n  OCR3A = pwmval / 3; \\\n})\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR3A = 0; \\\n  TCCR3B = _BV(WGM32) | _BV(CS30); \\\n  OCR3A = SYSCLOCK * USECPERTICK / 1000000; \\\n  TCNT3 = 0; \\\n})\n#if defined(CORE_OC3A_PIN)\n#define TIMER_PWM_PIN        CORE_OC3A_PIN  /* Teensy */\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define TIMER_PWM_PIN        5  /* Arduino Mega */\n#else\n#error \"Please add OC3A pin number here\\n\"\n#endif\n\n\n// defines for timer4 (10 bits, high speed option)\n#elif defined(IR_USE_TIMER4_HS)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR4A |= _BV(COM4A1))\n#define TIMER_DISABLE_PWM    (TCCR4A &= ~(_BV(COM4A1)))\n#define TIMER_ENABLE_INTR    (TIMSK4 = _BV(TOIE4))\n#define TIMER_DISABLE_INTR   (TIMSK4 = 0)\n#define TIMER_INTR_NAME      TIMER4_OVF_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint16_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR4A = (1<<PWM4A); \\\n  TCCR4B = _BV(CS40); \\\n  TCCR4C = 0; \\\n  TCCR4D = (1<<WGM40); \\\n  TCCR4E = 0; \\\n  TC4H = pwmval >> 8; \\\n  OCR4C = pwmval; \\\n  TC4H = (pwmval / 3) >> 8; \\\n  OCR4A = (pwmval / 3) & 255; \\\n})\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR4A = 0; \\\n  TCCR4B = _BV(CS40); \\\n  TCCR4C = 0; \\\n  TCCR4D = 0; \\\n  TCCR4E = 0; \\\n  TC4H = (SYSCLOCK * USECPERTICK / 1000000) >> 8; \\\n  OCR4C = (SYSCLOCK * USECPERTICK / 1000000) & 255; \\\n  TC4H = 0; \\\n  TCNT4 = 0; \\\n})\n#if defined(CORE_OC4A_PIN)\n#define TIMER_PWM_PIN        CORE_OC4A_PIN  /* Teensy */\n#elif defined(__AVR_ATmega32U4__)\n#define TIMER_PWM_PIN        13  /* Leonardo */\n#else\n#error \"Please add OC4A pin number here\\n\"\n#endif\n\n\n// defines for timer4 (16 bits)\n#elif defined(IR_USE_TIMER4)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR4A |= _BV(COM4A1))\n#define TIMER_DISABLE_PWM    (TCCR4A &= ~(_BV(COM4A1)))\n#define TIMER_ENABLE_INTR    (TIMSK4 = _BV(OCIE4A))\n#define TIMER_DISABLE_INTR   (TIMSK4 = 0)\n#define TIMER_INTR_NAME      TIMER4_COMPA_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint16_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR4A = _BV(WGM41); \\\n  TCCR4B = _BV(WGM43) | _BV(CS40); \\\n  ICR4 = pwmval; \\\n  OCR4A = pwmval / 3; \\\n})\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR4A = 0; \\\n  TCCR4B = _BV(WGM42) | _BV(CS40); \\\n  OCR4A = SYSCLOCK * USECPERTICK / 1000000; \\\n  TCNT4 = 0; \\\n})\n#if defined(CORE_OC4A_PIN)\n#define TIMER_PWM_PIN        CORE_OC4A_PIN\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define TIMER_PWM_PIN        6  /* Arduino Mega */\n#else\n#error \"Please add OC4A pin number here\\n\"\n#endif\n\n\n// defines for timer5 (16 bits)\n#elif defined(IR_USE_TIMER5)\n#define TIMER_RESET\n#define TIMER_ENABLE_PWM     (TCCR5A |= _BV(COM5A1))\n#define TIMER_DISABLE_PWM    (TCCR5A &= ~(_BV(COM5A1)))\n#define TIMER_ENABLE_INTR    (TIMSK5 = _BV(OCIE5A))\n#define TIMER_DISABLE_INTR   (TIMSK5 = 0)\n#define TIMER_INTR_NAME      TIMER5_COMPA_vect\n#define TIMER_CONFIG_KHZ(val) ({ \\\n  const uint16_t pwmval = SYSCLOCK / 2000 / (val); \\\n  TCCR5A = _BV(WGM51); \\\n  TCCR5B = _BV(WGM53) | _BV(CS50); \\\n  ICR5 = pwmval; \\\n  OCR5A = pwmval / 3; \\\n})\n#define TIMER_CONFIG_NORMAL() ({ \\\n  TCCR5A = 0; \\\n  TCCR5B = _BV(WGM52) | _BV(CS50); \\\n  OCR5A = SYSCLOCK * USECPERTICK / 1000000; \\\n  TCNT5 = 0; \\\n})\n#if defined(CORE_OC5A_PIN)\n#define TIMER_PWM_PIN        CORE_OC5A_PIN\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define TIMER_PWM_PIN        46  /* Arduino Mega */\n#else\n#error \"Please add OC5A pin number here\\n\"\n#endif\n\n\n#else // unknown timer\n#error \"Internal code configuration error, no known IR_USE_TIMER# defined\\n\"\n#endif\n\n\n// defines for blinking the LED\n#if defined(CORE_LED0_PIN)\n#define BLINKLED       CORE_LED0_PIN\n#define BLINKLED_ON()  (digitalWrite(CORE_LED0_PIN, HIGH))\n#define BLINKLED_OFF() (digitalWrite(CORE_LED0_PIN, LOW))\n#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)\n#define BLINKLED       13\n#define BLINKLED_ON()  (PORTB |= B10000000)\n#define BLINKLED_OFF() (PORTB &= B01111111)\n#elif defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644__)\n#define BLINKLED       0\n#define BLINKLED_ON()  (PORTD |= B00000001)\n#define BLINKLED_OFF() (PORTD &= B11111110)\n#else\n#define BLINKLED       13\n#define BLINKLED_ON()  (PORTB |= B00100000)\n#define BLINKLED_OFF() (PORTB &= B11011111)\n#endif\n\n#endif"
    }, {
      filename: "src/IRremote_ard.cpp",
      code: "/*\n * IRremote\n * Version 0.11 August, 2009\n * Copyright 2009 Ken Shirriff\n * For details, see http://arcfn.com/2009/08/multi-protocol-infrared-remote-library.html\n *\n * Modified by Paul Stoffregen <paul@pjrc.com> to support other boards and timers\n * Modified  by Mitra Ardron <mitra@mitra.biz> \n * Added Sanyo and Mitsubishi controllers\n * Modified Sony to spot the repeat codes that some Sony's send\n *\n * Interrupt code based on NECIRrcv by Joe Knapp\n * http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1210243556\n * Also influenced by http://zovirl.com/2008/11/12/building-a-universal-remote-with-an-arduino/\n *\n * JVC and Panasonic protocol added by Kristian Lauszus (Thanks to zenwheel and other people at the original blog post)\n */\n\n#include \"IRremote_ard.h\"\n#include \"IRremoteInt_ard.h\"\n\n// Provides ISR\n#include <avr/interrupt.h>\n\nvolatile irparams_t irparams;\n\n// These versions of MATCH, MATCH_MARK, and MATCH_SPACE are only for debugging.\n// To use them, set DEBUG in IRremoteInt.h\n// Normally macros are used for efficiency\n#ifdef DEBUG\nint MATCH(int measured, int desired) {\n  Serial.print(\"Testing: \");\n  Serial.print(TICKS_LOW(desired), DEC);\n  Serial.print(\" <= \");\n  Serial.print(measured, DEC);\n  Serial.print(\" <= \");\n  Serial.println(TICKS_HIGH(desired), DEC);\n  return measured >= TICKS_LOW(desired) && measured <= TICKS_HIGH(desired);\n}\n\nint MATCH_MARK(int measured_ticks, int desired_us) {\n  Serial.print(\"Testing mark \");\n  Serial.print(measured_ticks * USECPERTICK, DEC);\n  Serial.print(\" vs \");\n  Serial.print(desired_us, DEC);\n  Serial.print(\": \");\n  Serial.print(TICKS_LOW(desired_us + MARK_EXCESS), DEC);\n  Serial.print(\" <= \");\n  Serial.print(measured_ticks, DEC);\n  Serial.print(\" <= \");\n  Serial.println(TICKS_HIGH(desired_us + MARK_EXCESS), DEC);\n  return measured_ticks >= TICKS_LOW(desired_us + MARK_EXCESS) && measured_ticks <= TICKS_HIGH(desired_us + MARK_EXCESS);\n}\n\nint MATCH_SPACE(int measured_ticks, int desired_us) {\n  Serial.print(\"Testing space \");\n  Serial.print(measured_ticks * USECPERTICK, DEC);\n  Serial.print(\" vs \");\n  Serial.print(desired_us, DEC);\n  Serial.print(\": \");\n  Serial.print(TICKS_LOW(desired_us - MARK_EXCESS), DEC);\n  Serial.print(\" <= \");\n  Serial.print(measured_ticks, DEC);\n  Serial.print(\" <= \");\n  Serial.println(TICKS_HIGH(desired_us - MARK_EXCESS), DEC);\n  return measured_ticks >= TICKS_LOW(desired_us - MARK_EXCESS) && measured_ticks <= TICKS_HIGH(desired_us - MARK_EXCESS);\n}\n#else\nint MATCH(int measured, int desired) {return measured >= TICKS_LOW(desired) && measured <= TICKS_HIGH(desired);}\nint MATCH_MARK(int measured_ticks, int desired_us) {return MATCH(measured_ticks, (desired_us + MARK_EXCESS));}\nint MATCH_SPACE(int measured_ticks, int desired_us) {return MATCH(measured_ticks, (desired_us - MARK_EXCESS));}\n#endif\n\nIRrecv::IRrecv(int recvpin)\n{\n  irparams.recvpin = recvpin;\n  irparams.blinkflag = 0;\n}\n\n// initialization\nvoid IRrecv::enableIRIn() {\n  cli();\n  // setup pulse clock timer interrupt\n  //Prescale /8 (16M/8 = 0.5 microseconds per tick)\n  // Therefore, the timer interval can range from 0.5 to 128 microseconds\n  // depending on the reset value (255 to 0)\n  TIMER_CONFIG_NORMAL();\n\n  //Timer2 Overflow Interrupt Enable\n  TIMER_ENABLE_INTR;\n\n  TIMER_RESET;\n\n  sei();  // enable interrupts\n\n  // initialize state machine variables\n  irparams.rcvstate = STATE_IDLE;\n  irparams.rawlen = 0;\n\n  // set pin modes\n  pinMode(irparams.recvpin, INPUT);\n}\n\n// enable/disable blinking of pin 13 on IR processing\nvoid IRrecv::blink13(int blinkflag)\n{\n  irparams.blinkflag = blinkflag;\n  if (blinkflag)\n    pinMode(BLINKLED, OUTPUT);\n}\n\n// TIMER2 interrupt code to collect raw data.\n// Widths of alternating SPACE, MARK are recorded in rawbuf.\n// Recorded in ticks of 50 microseconds.\n// rawlen counts the number of entries recorded so far.\n// First entry is the SPACE between transmissions.\n// As soon as a SPACE gets long, ready is set, state switches to IDLE, timing of SPACE continues.\n// As soon as first MARK arrives, gap width is recorded, ready is cleared, and new logging starts\nISR(TIMER_INTR_NAME)\n{\n  TIMER_RESET;\n\n  uint8_t irdata = (uint8_t)digitalRead(irparams.recvpin);\n\n  irparams.timer++; // One more 50us tick\n  if (irparams.rawlen >= RAWBUF) {\n    // Buffer overflow\n    irparams.rcvstate = STATE_STOP;\n  }\n  switch(irparams.rcvstate) {\n  case STATE_IDLE: // In the middle of a gap\n    if (irdata == MARK) {\n      if (irparams.timer < GAP_TICKS) {\n        // Not big enough to be a gap.\n        irparams.timer = 0;\n      } \n      else {\n        // gap just ended, record duration and start recording transmission\n        irparams.rawlen = 0;\n        irparams.rawbuf[irparams.rawlen++] = irparams.timer;\n        irparams.timer = 0;\n        irparams.rcvstate = STATE_MARK;\n      }\n    }\n    break;\n  case STATE_MARK: // timing MARK\n    if (irdata == SPACE) {   // MARK ended, record time\n      irparams.rawbuf[irparams.rawlen++] = irparams.timer;\n      irparams.timer = 0;\n      irparams.rcvstate = STATE_SPACE;\n    }\n    break;\n  case STATE_SPACE: // timing SPACE\n    if (irdata == MARK) { // SPACE just ended, record it\n      irparams.rawbuf[irparams.rawlen++] = irparams.timer;\n      irparams.timer = 0;\n      irparams.rcvstate = STATE_MARK;\n    } \n    else { // SPACE\n      if (irparams.timer > GAP_TICKS) {\n        // big SPACE, indicates gap between codes\n        // Mark current code as ready for processing\n        // Switch to STOP\n        // Don't reset timer; keep counting space width\n        irparams.rcvstate = STATE_STOP;\n      } \n    }\n    break;\n  case STATE_STOP: // waiting, measuring gap\n    if (irdata == MARK) { // reset gap timer\n      irparams.timer = 0;\n    }\n    break;\n  }\n\n  if (irparams.blinkflag) {\n    if (irdata == MARK) {\n      BLINKLED_ON();  // turn pin 13 LED on\n    } \n    else {\n      BLINKLED_OFF();  // turn pin 13 LED off\n    }\n  }\n}\n\nvoid IRrecv::resume() {\n  irparams.rcvstate = STATE_IDLE;\n  irparams.rawlen = 0;\n}\n\n\n\n// Decodes the received IR message\n// Returns 0 if no data ready, 1 if data ready.\n// Results of decoding are stored in results\nint IRrecv::decode(decode_results *results) {\n  results->rawbuf = irparams.rawbuf;\n  results->rawlen = irparams.rawlen;\n  if (irparams.rcvstate != STATE_STOP) {\n    return ERR;\n  }\n\n#ifdef DEBUG\n  Serial.println(\"Attempting NEC decode\");\n#endif\n  if (decodeNEC(results)) {\n    return DECODED;\n  }\n/*\n#ifdef DEBUG\n  Serial.println(\"Attempting Sony decode\");\n#endif\n  if (decodeSony(results)) {\n    return DECODED;\n  }*/\n/*\n#ifdef DEBUG\n  Serial.println(\"Attempting Sanyo decode\");\n#endif\n  if (decodeSanyo(results)) {\n    return DECODED;\n  }\n  */\n/*\n#ifdef DEBUG\n  Serial.println(\"Attempting Mitsubishi decode\");\n#endif\n  if (decodeMitsubishi(results)) {\n    return DECODED;\n  }*/\n/*\n#ifdef DEBUG\n  Serial.println(\"Attempting RC5 decode\");\n#endif  \n  if (decodeRC5(results)) {\n    return DECODED;\n  }\n  */\n/*\n#ifdef DEBUG\n  Serial.println(\"Attempting RC6 decode\");\n#endif \n  if (decodeRC6(results)) {\n    return DECODED;\n  }\n  */\n/*\n#ifdef DEBUG\n    Serial.println(\"Attempting Panasonic decode\");\n#endif \n    if (decodePanasonic(results)) {\n        return DECODED;\n    }\n\t*/\n/*\n#ifdef DEBUG\n    Serial.println(\"Attempting JVC decode\");\n#endif \n    if (decodeJVC(results)) {\n        return DECODED;\n    }*/\n  // decodeHash returns a hash on any input.\n  // Thus, it needs to be last in the list.\n  // If you add any decodes, add them before this.\n  if (decodeHash(results)) {\n    return DECODED;\n  }\n  // Throw away and start over\n  resume();\n  return ERR;\n}\n\n\n// NECs have a repeat only 4 items long\nlong IRrecv::decodeNEC(decode_results *results) {\n  long data = 0;\n  int offset = 1; // Skip first space\n  // Initial mark\n  if (!MATCH_MARK(results->rawbuf[offset], NEC_HDR_MARK)) {\n    return ERR;\n  }\n  offset++;\n  // Check for repeat\n  if (irparams.rawlen == 4 &&\n    MATCH_SPACE(results->rawbuf[offset], NEC_RPT_SPACE) &&\n    MATCH_MARK(results->rawbuf[offset+1], NEC_BIT_MARK)) {\n    results->bits = 0;\n    results->value = REPEAT;\n    results->decode_type = NEC;\n    return DECODED;\n  }\n  if (irparams.rawlen < 2 * NEC_BITS + 4) {\n    return ERR;\n  }\n  // Initial space  \n  if (!MATCH_SPACE(results->rawbuf[offset], NEC_HDR_SPACE)) {\n    return ERR;\n  }\n  offset++;\n  for (int i = 0; i < NEC_BITS; i++) {\n    if (!MATCH_MARK(results->rawbuf[offset], NEC_BIT_MARK)) {\n      return ERR;\n    }\n    offset++;\n    if (MATCH_SPACE(results->rawbuf[offset], NEC_ONE_SPACE)) {\n      data = (data << 1) | 1;\n    } \n    else if (MATCH_SPACE(results->rawbuf[offset], NEC_ZERO_SPACE)) {\n      data <<= 1;\n    } \n    else {\n      return ERR;\n    }\n    offset++;\n  }\n  // Success\n  results->bits = NEC_BITS;\n  results->value = data;\n  results->decode_type = NEC;\n  return DECODED;\n}\n/*\nlong IRrecv::decodeSony(decode_results *results) {\n  long data = 0;\n  if (irparams.rawlen < 2 * SONY_BITS + 2) {\n    return ERR;\n  }\n  int offset = 0; // Dont skip first space, check its size\n\n  // Some Sony's deliver repeats fast after first\n  // unfortunately can't spot difference from of repeat from two fast clicks\n  if (results->rawbuf[offset] < SONY_DOUBLE_SPACE_USECS) {\n    // Serial.print(\"IR Gap found: \");\n    results->bits = 0;\n    results->value = REPEAT;\n    results->decode_type = SANYO;\n    return DECODED;\n  }\n  offset++;\n\n  // Initial mark\n  if (!MATCH_MARK(results->rawbuf[offset], SONY_HDR_MARK)) {\n    return ERR;\n  }\n  offset++;\n\n  while (offset + 1 < irparams.rawlen) {\n    if (!MATCH_SPACE(results->rawbuf[offset], SONY_HDR_SPACE)) {\n      break;\n    }\n    offset++;\n    if (MATCH_MARK(results->rawbuf[offset], SONY_ONE_MARK)) {\n      data = (data << 1) | 1;\n    } \n    else if (MATCH_MARK(results->rawbuf[offset], SONY_ZERO_MARK)) {\n      data <<= 1;\n    } \n    else {\n      return ERR;\n    }\n    offset++;\n  }\n\n  // Success\n  results->bits = (offset - 1) / 2;\n  if (results->bits < 12) {\n    results->bits = 0;\n    return ERR;\n  }\n  results->value = data;\n  results->decode_type = SONY;\n  return DECODED;\n}*/\n\n/*\n// I think this is a Sanyo decoder - serial = SA 8650B\n// Looks like Sony except for timings, 48 chars of data and time/space different\nlong IRrecv::decodeSanyo(decode_results *results) {\n  long data = 0;\n  if (irparams.rawlen < 2 * SANYO_BITS + 2) {\n    return ERR;\n  }\n  int offset = 0; // Skip first space\n  // Initial space  \n  // Put this back in for debugging - note can't use #DEBUG as if Debug on we don't see the repeat cos of the delay\n  //Serial.print(\"IR Gap: \");\n  //Serial.println( results->rawbuf[offset]);\n  //Serial.println( \"test against:\");\n  //Serial.println(results->rawbuf[offset]);\n  \n  if (results->rawbuf[offset] < SANYO_DOUBLE_SPACE_USECS) {\n    // Serial.print(\"IR Gap found: \");\n    results->bits = 0;\n    results->value = REPEAT;\n    results->decode_type = SANYO;\n    return DECODED;\n  }\n  offset++;\n\n  // Initial mark\n  if (!MATCH_MARK(results->rawbuf[offset], SANYO_HDR_MARK)) {\n    return ERR;\n  }\n  offset++;\n\n  // Skip Second Mark\n  if (!MATCH_MARK(results->rawbuf[offset], SANYO_HDR_MARK)) {\n    return ERR;\n  }\n  offset++;\n\n  while (offset + 1 < irparams.rawlen) {\n    if (!MATCH_SPACE(results->rawbuf[offset], SANYO_HDR_SPACE)) {\n      break;\n    }\n    offset++;\n    if (MATCH_MARK(results->rawbuf[offset], SANYO_ONE_MARK)) {\n      data = (data << 1) | 1;\n    } \n    else if (MATCH_MARK(results->rawbuf[offset], SANYO_ZERO_MARK)) {\n      data <<= 1;\n    } \n    else {\n      return ERR;\n    }\n    offset++;\n  }\n\n  // Success\n  results->bits = (offset - 1) / 2;\n  if (results->bits < 12) {\n    results->bits = 0;\n    return ERR;\n  }\n  results->value = data;\n  results->decode_type = SANYO;\n  return DECODED;\n}\n*/\n/*\n// Looks like Sony except for timings, 48 chars of data and time/space different\nlong IRrecv::decodeMitsubishi(decode_results *results) {\n  // Serial.print(\"?!? decoding Mitsubishi:\");Serial.print(irparams.rawlen); Serial.print(\" want \"); Serial.println( 2 * MITSUBISHI_BITS + 2);\n  long data = 0;\n  if (irparams.rawlen < 2 * MITSUBISHI_BITS + 2) {\n    return ERR;\n  }\n  int offset = 0; // Skip first space\n  // Initial space  \n  // Put this back in for debugging - note can't use #DEBUG as if Debug on we don't see the repeat cos of the delay\n  //Serial.print(\"IR Gap: \");\n  //Serial.println( results->rawbuf[offset]);\n  //Serial.println( \"test against:\");\n  //Serial.println(results->rawbuf[offset]);\n  \n  // Not seeing double keys from Mitsubishi\n  //if (results->rawbuf[offset] < MITSUBISHI_DOUBLE_SPACE_USECS) {\n    // Serial.print(\"IR Gap found: \");\n  //  results->bits = 0;\n  //  results->value = REPEAT;\n  //  results->decode_type = MITSUBISHI;\n  //  return DECODED;\n  //}\n  \n  offset++;\n\n  // Typical\n  // 14200 7 41 7 42 7 42 7 17 7 17 7 18 7 41 7 18 7 17 7 17 7 18 7 41 8 17 7 17 7 18 7 17 7 \n\n  // Initial Space\n  if (!MATCH_MARK(results->rawbuf[offset], MITSUBISHI_HDR_SPACE)) {\n    return ERR;\n  }\n  offset++;\n  while (offset + 1 < irparams.rawlen) {\n    if (MATCH_MARK(results->rawbuf[offset], MITSUBISHI_ONE_MARK)) {\n      data = (data << 1) | 1;\n    } \n    else if (MATCH_MARK(results->rawbuf[offset], MITSUBISHI_ZERO_MARK)) {\n      data <<= 1;\n    } \n    else {\n      // Serial.println(\"A\"); Serial.println(offset); Serial.println(results->rawbuf[offset]);\n      return ERR;\n    }\n    offset++;\n    if (!MATCH_SPACE(results->rawbuf[offset], MITSUBISHI_HDR_SPACE)) {\n      // Serial.println(\"B\"); Serial.println(offset); Serial.println(results->rawbuf[offset]);\n      break;\n    }\n    offset++;\n  }\n\n  // Success\n  results->bits = (offset - 1) / 2;\n  if (results->bits < MITSUBISHI_BITS) {\n    results->bits = 0;\n    return ERR;\n  }\n  results->value = data;\n  results->decode_type = MITSUBISHI;\n  return DECODED;\n}*/\n\n\n// Gets one undecoded level at a time from the raw buffer.\n// The RC5/6 decoding is easier if the data is broken into time intervals.\n// E.g. if the buffer has MARK for 2 time intervals and SPACE for 1,\n// successive calls to getRClevel will return MARK, MARK, SPACE.\n// offset and used are updated to keep track of the current position.\n// t1 is the time interval for a single bit in microseconds.\n// Returns -1 for error (measured time interval is not a multiple of t1).\nint IRrecv::getRClevel(decode_results *results, int *offset, int *used, int t1) {\n  if (*offset >= results->rawlen) {\n    // After end of recorded buffer, assume SPACE.\n    return SPACE;\n  }\n  int width = results->rawbuf[*offset];\n  int val = ((*offset) % 2) ? MARK : SPACE;\n  int correction = (val == MARK) ? MARK_EXCESS : - MARK_EXCESS;\n\n  int avail;\n  if (MATCH(width, t1 + correction)) {\n    avail = 1;\n  } \n  else if (MATCH(width, 2*t1 + correction)) {\n    avail = 2;\n  } \n  else if (MATCH(width, 3*t1 + correction)) {\n    avail = 3;\n  } \n  else {\n    return -1;\n  }\n\n  (*used)++;\n  if (*used >= avail) {\n    *used = 0;\n    (*offset)++;\n  }\n#ifdef DEBUG\n  if (val == MARK) {\n    Serial.println(\"MARK\");\n  } \n  else {\n    Serial.println(\"SPACE\");\n  }\n#endif\n  return val;   \n}\n/*\nlong IRrecv::decodeRC5(decode_results *results) {\n  if (irparams.rawlen < MIN_RC5_SAMPLES + 2) {\n    return ERR;\n  }\n  int offset = 1; // Skip gap space\n  long data = 0;\n  int used = 0;\n  // Get start bits\n  if (getRClevel(results, &offset, &used, RC5_T1) != MARK) return ERR;\n  if (getRClevel(results, &offset, &used, RC5_T1) != SPACE) return ERR;\n  if (getRClevel(results, &offset, &used, RC5_T1) != MARK) return ERR;\n  int nbits;\n  for (nbits = 0; offset < irparams.rawlen; nbits++) {\n    int levelA = getRClevel(results, &offset, &used, RC5_T1); \n    int levelB = getRClevel(results, &offset, &used, RC5_T1);\n    if (levelA == SPACE && levelB == MARK) {\n      // 1 bit\n      data = (data << 1) | 1;\n    } \n    else if (levelA == MARK && levelB == SPACE) {\n      // zero bit\n      data <<= 1;\n    } \n    else {\n      return ERR;\n    } \n  }\n\n  // Success\n  results->bits = nbits;\n  results->value = data;\n  results->decode_type = RC5;\n  return DECODED;\n}*/\n/*\nlong IRrecv::decodeRC6(decode_results *results) {\n  if (results->rawlen < MIN_RC6_SAMPLES) {\n    return ERR;\n  }\n  int offset = 1; // Skip first space\n  // Initial mark\n  if (!MATCH_MARK(results->rawbuf[offset], RC6_HDR_MARK)) {\n    return ERR;\n  }\n  offset++;\n  if (!MATCH_SPACE(results->rawbuf[offset], RC6_HDR_SPACE)) {\n    return ERR;\n  }\n  offset++;\n  long data = 0;\n  int used = 0;\n  // Get start bit (1)\n  if (getRClevel(results, &offset, &used, RC6_T1) != MARK) return ERR;\n  if (getRClevel(results, &offset, &used, RC6_T1) != SPACE) return ERR;\n  int nbits;\n  for (nbits = 0; offset < results->rawlen; nbits++) {\n    int levelA, levelB; // Next two levels\n    levelA = getRClevel(results, &offset, &used, RC6_T1); \n    if (nbits == 3) {\n      // T bit is double wide; make sure second half matches\n      if (levelA != getRClevel(results, &offset, &used, RC6_T1)) return ERR;\n    } \n    levelB = getRClevel(results, &offset, &used, RC6_T1);\n    if (nbits == 3) {\n      // T bit is double wide; make sure second half matches\n      if (levelB != getRClevel(results, &offset, &used, RC6_T1)) return ERR;\n    } \n    if (levelA == MARK && levelB == SPACE) { // reversed compared to RC5\n      // 1 bit\n      data = (data << 1) | 1;\n    } \n    else if (levelA == SPACE && levelB == MARK) {\n      // zero bit\n      data <<= 1;\n    } \n    else {\n      return ERR; // Error\n    } \n  }\n  // Success\n  results->bits = nbits;\n  results->value = data;\n  results->decode_type = RC6;\n  return DECODED;\n}*/\n/*\nlong IRrecv::decodePanasonic(decode_results *results) {\n    unsigned long long data = 0;\n    int offset = 1;\n    \n    if (!MATCH_MARK(results->rawbuf[offset], PANASONIC_HDR_MARK)) {\n        return ERR;\n    }\n    offset++;\n    if (!MATCH_MARK(results->rawbuf[offset], PANASONIC_HDR_SPACE)) {\n        return ERR;\n    }\n    offset++;\n    \n    // decode address\n    for (int i = 0; i < PANASONIC_BITS; i++) {\n        if (!MATCH_MARK(results->rawbuf[offset++], PANASONIC_BIT_MARK)) {\n            return ERR;\n        }\n        if (MATCH_SPACE(results->rawbuf[offset],PANASONIC_ONE_SPACE)) {\n            data = (data << 1) | 1;\n        } else if (MATCH_SPACE(results->rawbuf[offset],PANASONIC_ZERO_SPACE)) {\n            data <<= 1;\n        } else {\n            return ERR;\n        }\n        offset++;\n    }\n    results->value = (unsigned long)data;\n    results->panasonicAddress = (unsigned int)(data >> 32);\n    results->decode_type = PANASONIC;\n    results->bits = PANASONIC_BITS;\n    return DECODED;\n}*/\n/*\nlong IRrecv::decodeJVC(decode_results *results) {\n    long data = 0;\n    int offset = 1; // Skip first space\n    // Check for repeat\n    if (irparams.rawlen - 1 == 33 &&\n        MATCH_MARK(results->rawbuf[offset], JVC_BIT_MARK) &&\n        MATCH_MARK(results->rawbuf[irparams.rawlen-1], JVC_BIT_MARK)) {\n        results->bits = 0;\n        results->value = REPEAT;\n        results->decode_type = JVC;\n        return DECODED;\n    } \n    // Initial mark\n    if (!MATCH_MARK(results->rawbuf[offset], JVC_HDR_MARK)) {\n        return ERR;\n    }\n    offset++; \n    if (irparams.rawlen < 2 * JVC_BITS + 1 ) {\n        return ERR;\n    }\n    // Initial space \n    if (!MATCH_SPACE(results->rawbuf[offset], JVC_HDR_SPACE)) {\n        return ERR;\n    }\n    offset++;\n    for (int i = 0; i < JVC_BITS; i++) {\n        if (!MATCH_MARK(results->rawbuf[offset], JVC_BIT_MARK)) {\n            return ERR;\n        }\n        offset++;\n        if (MATCH_SPACE(results->rawbuf[offset], JVC_ONE_SPACE)) {\n            data = (data << 1) | 1;\n        } \n        else if (MATCH_SPACE(results->rawbuf[offset], JVC_ZERO_SPACE)) {\n            data <<= 1;\n        } \n        else {\n            return ERR;\n        }\n        offset++;\n    }\n    //Stop bit\n    if (!MATCH_MARK(results->rawbuf[offset], JVC_BIT_MARK)){\n        return ERR;\n    }\n    // Success\n    results->bits = JVC_BITS;\n    results->value = data;\n    results->decode_type = JVC;\n    return DECODED;\n}*/\n\n/* -----------------------------------------------------------------------\n * hashdecode - decode an arbitrary IR code.\n * Instead of decoding using a standard encoding scheme\n * (e.g. Sony, NEC, RC5), the code is hashed to a 32-bit value.\n *\n * The algorithm: look at the sequence of MARK signals, and see if each one\n * is shorter (0), the same length (1), or longer (2) than the previous.\n * Do the same with the SPACE signals.  Hszh the resulting sequence of 0's,\n * 1's, and 2's to a 32-bit value.  This will give a unique value for each\n * different code (probably), for most code systems.\n *\n * http://arcfn.com/2010/01/using-arbitrary-remotes-with-arduino.html\n */\n\n// Compare two tick values, returning 0 if newval is shorter,\n// 1 if newval is equal, and 2 if newval is longer\n// Use a tolerance of 20%\nint IRrecv::compare(unsigned int oldval, unsigned int newval) {\n  if (newval < oldval * .8) {\n    return 0;\n  } \n  else if (oldval < newval * .8) {\n    return 2;\n  } \n  else {\n    return 1;\n  }\n}\n\n// Use FNV hash algorithm: http://isthe.com/chongo/tech/comp/fnv/#FNV-param\n#define FNV_PRIME_32 16777619\n#define FNV_BASIS_32 2166136261\n\n/* Converts the raw code values into a 32-bit hash code.\n * Hopefully this code is unique for each button.\n * This isn't a \"real\" decoding, just an arbitrary value.\n */\nlong IRrecv::decodeHash(decode_results *results) {\n  // Require at least 6 samples to prevent triggering on noise\n  if (results->rawlen < 6) {\n    return ERR;\n  }\n  long hash = FNV_BASIS_32;\n  for (int i = 1; i+2 < results->rawlen; i++) {\n    int value =  compare(results->rawbuf[i], results->rawbuf[i+2]);\n    // Add value into the hash\n    hash = (hash * FNV_PRIME_32) ^ value;\n  }\n  results->value = hash;\n  results->bits = 32;\n  results->decode_type = UNKNOWN;\n  return DECODED;\n}\n"
    }, {
      filename: "src/IRremote_ard.h",
      code: "/*\n * IRremote\n * Version 0.1 July, 2009\n * Copyright 2009 Ken Shirriff\n * For details, see http://arcfn.com/2009/08/multi-protocol-infrared-remote-library.htm http://arcfn.com\n * Edited by Mitra to add new controller SANYO\n *\n * Interrupt code based on NECIRrcv by Joe Knapp\n * http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1210243556\n * Also influenced by http://zovirl.com/2008/11/12/building-a-universal-remote-with-an-arduino/\n *\n * JVC and Panasonic protocol added by Kristian Lauszus (Thanks to zenwheel and other people at the original blog post)\n */\n\n#ifndef IRremote_h\n#define IRremote_h\n\n// The following are compile-time library options.\n// If you change them, recompile the library.\n// If DEBUG is defined, a lot of debugging output will be printed during decoding.\n// TEST must be defined for the IRtest unittests to work.  It will make some\n// methods virtual, which will be slightly slower, which is why it is optional.\n// #define DEBUG\n// #define TEST\n\n// Results returned from the decoder\nclass decode_results {\npublic:\n  int decode_type; // NEC, SONY, RC5, UNKNOWN\n  unsigned int panasonicAddress; // This is only used for decoding Panasonic data\n  unsigned long value; // Decoded value\n  int bits; // Number of bits in decoded value\n  volatile unsigned int *rawbuf; // Raw intervals in .5 us ticks\n  int rawlen; // Number of records in rawbuf.\n};\n\n// Values for decode_type\n#define NEC 1\n#define SONY 2\n#define RC5 3\n#define RC6 4\n#define DISH 5\n#define SHARP 6\n#define PANASONIC 7\n#define JVC 8\n#define SANYO 9\n#define MITSUBISHI 10\n#define UNKNOWN -1\n\n// Decoded value for NEC when a repeat code is received\n#define REPEAT 0xffffffff\n\n// main class for receiving IR\nclass IRrecv\n{\npublic:\n  IRrecv(int recvpin);\n  void blink13(int blinkflag);\n  int decode(decode_results *results);\n  void enableIRIn();\n  void resume();\nprivate:\n  // These are called by decode\n  int getRClevel(decode_results *results, int *offset, int *used, int t1);\n  long decodeNEC(decode_results *results);\n  //long decodeSony(decode_results *results);\n  //long decodeSanyo(decode_results *results);\n  //long decodeMitsubishi(decode_results *results);\n  //long decodeRC5(decode_results *results);\n  //long decodeRC6(decode_results *results);\n  //long decodePanasonic(decode_results *results);\n  //long decodeJVC(decode_results *results);\n  long decodeHash(decode_results *results);\n  int compare(unsigned int oldval, unsigned int newval);\n\n} \n;\n\n// Only used for testing; can remove virtual for shorter code\n#ifdef TEST\n#define VIRTUAL virtual\n#else\n#define VIRTUAL\n#endif\n// Some useful constants\n\n#define USECPERTICK 50  // microseconds per clock interrupt tick\n#define RAWBUF 100 // Length of raw duration buffer\n\n// Marks tend to be 100us too long, and spaces 100us too short\n// when received due to sensor lag.\n#define MARK_EXCESS 100\n\n#endif"
    }]
  };
  const extFacePanels = {};
  const ExtHandler = {
    onLoad: function onLoad(app, target) {
      const that = this;

      if (!that.__workerSetupInstance) {
        that.__workerSetupInstance = that.workerSetup({
          app
        }).then(() => {
          that.worker.remote.runExtension('onLoad', target.id);
        });
      }
    },
    onUnload: function onUnload(app) {
      this.__workerSetupInstance = null;
      this.worker.remote.runExtension('onUnload');
      this.worker.dispose();
    },
    onConnect: function onConnect(app, device) {
      this.worker.remote.runExtension('onConnect', device.id);
    },
    onDisconnect: function onDisconnect(app, device) {
      this.worker.remote.runExtension('onDisconnect', device.id);
    },
    onStopAll: function onStopAll(app, device) {
      this.worker.remote.runExtension('onStopAll', device.id);
    },
    beforeChangeUploadMode: function beforeChangeUploadMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeUploadMode', device.id);
    },
    beforeChangeDebugMode: function beforeChangeDebugMode(app, device) {
      return this.worker.remote.runExtension('beforeChangeDebugMode', device.id);
    },
    afterChangeUploadMode: function afterChangeUploadMode(app, device) {
      this.worker.remote.runExtension('afterChangeUploadMode', device.id);
    },
    afterChangeDebugMode: function afterChangeDebugMode(app, device) {
      this.worker.remote.runExtension('afterChangeDebugMode', device.id);
    },
    onSelect: function onSelect(app, device) {
      if (!this.worker) {
        setTimeout(() => {
          this.onSelect(app, device);
        }, 200);
        return;
      }

      this.worker.remote.runExtension('onSelect', device.id);
    },
    onUnselect: function onUnselect(app, device) {
      this.worker.remote.runExtension('onUnselect', device.id);
    },
    beforeCodeUpload: function beforeCodeUpload(app, device) {
      this.worker.remote.runExtension('beforeCodeUpload', device.id);
    },
    afterCodeUpload: function afterCodeUpload(app, device) {
      this.worker.remote.runExtension('afterCodeUpload', device.id);
    },
    onRead: function onRead(app, device) {
      this.worker.remote.runExtension('onRead', device.id);
    },
    beforeFirmwareUpdate: function beforeFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('beforeFirmwareUpdate', device.id);
    },
    afterFirmwareUpdate: function afterFirmwareUpdate(app, device) {
      this.worker.remote.runExtension('afterFirmwareUpdate', device.id);
    }
  };

  class ExtInfaredIrBestCodesArduinoRemote {
    constructor() {
      this.checkFirmwareInForce = typeof checkFirmwareInForce !== 'undefined' ? checkFirmwareInForce : false;
      const handlerProxyUrl = window.MbApi.getExtResPath('infared_ir_best_codes_arduino_remote/handlerProxy.js', 'infared_ir_best_codes_arduino_remote');
      const that = this;

      that.workerSetup = async function (exports) {
        that.worker = await window.__web_worker_rpc.create(handlerProxyUrl, exports).then(worker => {
          worker.CONFIG.TIMEOUT = 42000;
          worker.CONFIG.HEARTBEAT = 4200;

          worker.onFail = () => {
            that.worker = null;
            that.workerSetup(exports);
            const app = exports.app;

            if (app) {
              app.workspace.resetEvents();
            }
          };

          return worker;
        });
      };

      this.funcs = {
        'BLOCK_1653576003808': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1653576003808', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        },
        'BLOCK_1653588721838': {
          onRun: (args, app, device, block) => {
            return this.worker.remote.runBlock('BLOCK_1653588721838', 'onRun', device.id, {
              id: block.id,
              opcode: block.opcode,
              arguments: block.arguments
            }, Object.assign({}, args));
          }
        }
      };
    }

    getInfo() {
      return {
        "id": "infared_ir_best_codes_arduino_remote",
        "targets": [{
          "name": "arduino_uno",
          "options": {
            "upload": {
              "middlewares": [{
                "name": "arduino",
                "params": {
                  "sources": extSources.arduino
                }
              }]
            }
          }
        }],
        "codeTypes": ["arduinoc"],
        "version": "0.0.3",
        "platform": ["mblockpc", "mblockweb"],
        "categories": [{
          "name": "cate_0db9b236",
          "colors": ["#4A4A4A", "#434343", "#3B3B3B"],
          "menuIconURI": "",
          "blockIcon": null,
          "blocks": [{
            "opcode": "BLOCK_1653576003808",
            "blockType": "string",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "ICON": {
                "type": "image",
                "width": 28,
                "height": 26,
                "src": window.MbApi.getExtResPath('infared_ir_best_codes_arduino_remote/imgs/4bbeff1d82e84e69a2a0aeade047ac7c.jpeg', 'infared_ir_best_codes_arduino_remote')
              },
              "PORT": {
                "type": "number",
                "defaultValue": 2
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `getKey()`,
                "sections": {
                  "include": ["\"src/IRremoteExt.h\""],
                  "declare": `int getKey(){\n   handleIRremote();\n    unsigned long value = getPressedIRremote();\n    if( value != 0xffffffff){\n \n     //Serial.println(value,HEX);\n      return value;\n    } \n    return -1;\n    \n}`,
                  "setup": `beginIRremote(/*{{this.PORT === 'None' ? 0 : this.PORT}}*/);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1653576003808
          }, {
            "opcode": "BLOCK_1653588721838",
            "blockType": "boolean",
            "checkboxInFlyout": false,
            "hidden": false,
            "gap": 12,
            "arguments": {
              "IMAGE": {
                "type": "image",
                "width": 28,
                "height": 26,
                "src": window.MbApi.getExtResPath('infared_ir_best_codes_arduino_remote/imgs/e0db0831db1148d382d3e2de78db451b.jpeg', 'infared_ir_best_codes_arduino_remote')
              },
              "pin": {
                "type": "number",
                "defaultValue": 2
              },
              "remtype": {
                "type": "fieldMenu",
                "defaultValue": "RC5",
                "menu": "BLOCK_1653588721838_REMTYPE"
              }
            },
            "branchCount": 0,
            "platform": ["mblockpc", "mblockweb"],
            "codes": {
              "arduinoc": {
                "code": `gettype()`,
                "sections": {
                  "include": ["\"src/IRremoteExt.h\""],
                  "declare": `int gettype(){\nString IR_type=\"UNKNOWN\";\n    String typelist[14]={\"UNKNOWN\", \"NEC\", \"SONY\", \"RC5\", \"RC6\", \"DISH\", \"SHARP\", \"PANASONIC\", \"JVC\", \"SANYO\", \"MITSUBISHI\", \"SAMSUNG\", \"LG\", \"WHYNTER\"};\n    if(results_/*{remtype}*/.decode_type>=1&&results_/*{remtype}*/.decode_type<=13){\n      IR_type=typelist[results_/*{remtype}*/.decode_type];\n    }\n    return IR_type;`,
                  "setup": `beginIRremote(/*{{this.PORT === 'None' ? 0 : this.PORT}}*/);`
                }
              }
            },
            "handler": this.funcs.BLOCK_1653588721838
          }],
          "menus": {
            "BLOCK_1653588721838_REMTYPE": [{
              "text": "BLOCK_1653588721838_REMTYPE_0",
              "value": "UNKNOWN"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_1",
              "value": "NECS"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_2",
              "value": "SONY"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_3",
              "value": "RC5"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_4",
              "value": "RC6"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_5",
              "value": "DISH"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_6",
              "value": "SHARP"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_7",
              "value": "PANASONIC"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_8",
              "value": "JVC"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_9",
              "value": "SANYO"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_10",
              "value": "MITSUBISHI"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_11",
              "value": "SAMSUNG"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_12",
              "value": "LG"
            }, {
              "text": "BLOCK_1653588721838_REMTYPE_13",
              "value": "WHYNTER"
            }]
          }
        }],
        "generators": extGenerators,
        "translationMap": extTranslationMap,
        "snippets": codeSnippets,
        "generatorStartBlocks": [],
        "feature": ["worker"],
        "mustLoginBlocks": [],
        "disabledOffline": [],
        "disabledOnline": ["infared_ir_best_codes_arduino_remote.BLOCK_1653576003808", "infared_ir_best_codes_arduino_remote.BLOCK_1653588721838"]
      };
    }

    getHandler() {
      if (typeof ExtHandler === 'object') {
        return ExtHandler;
      } else if (typeof ExtHandler === 'function') {
        return new ExtHandler();
      }
    }

  }

  var _default = ExtInfaredIrBestCodesArduinoRemote;
  _exports.default = _default;
});